function draw_grid (x, y, gw, gh, gsize, border=3) {
  ctx.save();
  ctx.translate(x, y);
  ctx.fillStyle = '#303030';
  ctx.fillRect(0, 0, gw*gsize, gh*gsize);

  ctx.beginPath();
  ctx.strokeStyle = '#D0D0D0';
  ctx.lineWidth = border;
  ctx.rect(0, 0, gw*gsize, gh*gsize);
  ctx.stroke();

  ctx.strokeStyle = '#909090';
  ctx.lineWidth = 1;
  for (let i = 0; i < gw; i++) {
    ctx.moveTo(i * gsize, 0);
    ctx.lineTo(i * gsize, gh*gsize);
  }
  for (let j = 0; j < gh; j++) {
    ctx.moveTo(0, j * gsize);
    ctx.lineTo(gw*gsize, j * gsize);
  }
  ctx.stroke();

  ctx.beginPath()
  ctx.strokeStyle = '#D0D0D0';
  ctx.lineWidth = border;
  ctx.moveTo(0, gh * gsize / 2);
  ctx.lineTo(gw*gsize, gh*gsize / 2);

  ctx.stroke();
  ctx.restore();
}

function draw_battle () {
  ctx.save();
  ctx.fillStyle = '#500000';
  ctx.fillRect(0, 0, st.width, st.height);
  draw_grid (st.grid_loc[0], st.grid_loc[1], 8, 8, st.gsize);
  for (const a of st.battle.aunits) {
    a.draw();
  }

  if (debug.draw_targets) {
    st.battle.aunits.forEach(a => a.draw_target());
  }
  st.battle.aunits.forEach(a => a.draw_health());

  for (const effect of st.effects) {
    if (st.frame >= effect.timeout) {
      effect._delete = true;
      continue;
    }
    effect.draw(effect);
  }

  if (st.battle.winner) {
    ctx.fillStyle = "#A0A0A0";
    ctx.font = '20px Courier New';
    ctx.fillText("Winner: " + st.battle.winner, 430, 30);
  }

  ctx.restore();
}
