// state
st = {
  grid_loc : [10, 10],
  gsize : 100,
  frame : 0,
  fps : 60,
  epsilon : 0.01,
  effects : [],
};

debug = {
  draw_targets : false,
};

function init () {
  let girf = new Unit('girf', 1, 'soldier', 'light', 'spell1');
  let minmin = new Unit('minmin', 2, 'soldier', 'dark', 'spell2');
  let luq = new Unit('luq', 1, 'archer', 'water', 'spell3');
  let jon = new Unit('jon', 1, 'archer', 'fire', 'spell4');
  let player_aunits = [
    new AUnit(girf, 3, 4, true),
    new AUnit(minmin, 4, 4, true),
    new AUnit(luq, 3, 5, true),
    new AUnit(jon, 4, 5, true),
  ];
  let enemy_aunits = [
    new AUnit(Object.assign({}, girf), 3, 2, false),
    new AUnit(Object.assign({}, minmin), 2, 1, false),
    new AUnit(Object.assign({}, luq), 3, 1, false),
    new AUnit(Object.assign({}, jon), 4, 1, false),
  ];
  for (const eu of enemy_aunits) {
    eu.unit.name = 'evil ' + eu.unit.name;
  }
  st.battle = {
    aunits : player_aunits.concat(enemy_aunits),
  }
  console.log('init end');
}

window.onload = function () {
  canvas = document.getElementById('td');
  st.width = canvas.width;
  st.height = canvas.height;
  ctx = canvas.getContext('2d');
  init();
  main();
}

window.main = function () {
  //console.log('main start');
  window.requestAnimationFrame(main);
  sim_battle();
  draw_battle();
  //console.log('main end');
  st.frame++;
}
